]> git.decadent.org.uk Git - dak.git/blob - config/debian/common
c9363bc8d1f294669533cbabf312e53a17fb3059
[dak.git] / config / debian / common
1 # -*- mode:sh -*-
2 # log something (basically echo it together with a timestamp)
3 #
4 # Set $PROGRAM to a string to have it added to the output.
5 function log () {
6     local prefix=${PROGRAM:-}
7     echo "$(date +"%b %d %H:%M:%S") $(hostname -s) ${prefix}[$$]: $@"
8 }
9
10 # log the message using log() but then also send a mail
11 # to the address configured in MAILTO (if non-empty)
12 function log_error () {
13     log "$@"
14     if [ -z "${MAILTO}" ]; then
15         echo "$@" | mail -a "X-Debian: DAK" -e -s "[$PROGRAM@$(hostname -s)] ERROR [$$]" -a "From: Debian FTP Masters <ftpmaster@ftp-master.debian.org>" ${MAILTO}
16     fi
17 }
18
19 # debug log, only output when DEBUG=1
20 function debug () {
21     if [ $DEBUG -eq 1 ]; then
22         log "$*"
23     fi
24 }
25
26 # Function that only cleans tempfiles, but does not exit or otherwise
27 # care about any exit status
28 function cleantempfiles() {
29     resolvetmpfiles
30     for TEMPFILE in $TMPFILES; do
31         if [ -n "${TEMPFILE}" ] && [ -f "${TEMPFILE}" ]; then
32             rm -f "${TEMPFILE}"
33         elif [ -n "${TEMPFILE}" ] && [ -d "${TEMPFILE}" ]; then
34             if [ "${TEMPFILE}" != "/" ] && [ "${TEMPFILE}" != "/*" ]; then
35                 rm -rf "${TEMPFILE}"
36             fi
37         fi
38     done
39     TMPFILES=""
40 }
41
42 function resolvetmpfiles() {
43     # If you don't understand this better not touch the script
44     for TEMPFILE in $TEMPFILES; do
45         TMPFILES="${TMPFILES} ${!TEMPFILE:-""}"
46     done
47     TEMPFILES=""
48 }
49
50 # Function cleanup
51 # No arguments
52 # Cleans up any known tempfile.
53 # Just ensure your script sets the variable
54 # TEMPFILES to the names of variables of tempfiles
55 # Or TMPFILES to the pathes of tempfiles
56 function cleanup() {
57     ERRVAL=$?
58     trap - ERR EXIT TERM HUP INT QUIT
59
60     cleantempfiles
61
62     return $ERRVAL
63 }
64 TEMPFILES=${TEMPFILES:-""}
65 TMPFILES=${TMPFILES:-""}
66
67 # Timestamp. Used for dinstall stat graphs
68 function ts() {
69     echo "Archive maintenance timestamp ($1): $(date +%H:%M:%S)"
70 }
71
72 ########################################################################
73 ########################################################################
74
75 function wbtrigger() {
76     SSHOPT="-n -o BatchMode=yes -o ConnectTimeout=30 -o SetupTimeout=240"
77     if lockfile -r 3 -l 3600 "${LOCK_BUILDD}"; then
78         ssh -q -q ${SSHOPT} wbadm@buildd /srv/wanna-build/trigger.often
79     fi
80     rm -f "${LOCK_BUILDD}"
81 }
82
83 # used by cron.dinstall *and* cron.unchecked.
84 function make_buildd_dir () {
85     # We generate straight into the static mirror location for incoming
86     dak manage-build-queues -a
87     dak generate-packages-sources2 -a build-queues
88     dak generate-releases -a build-queues >/dev/null
89
90     # Stick a last modified date in the page footer
91     echo "<p>Last updated: `date -u`</p>" > ${incoming}/web/README.html
92
93     # Tell the mirrors that we've updated
94     chronic /usr/local/bin/static-update-component incoming.debian.org
95 }
96
97 # Process (oldstable)-proposed-updates "NEW" queue
98 function punew_do() {
99     local queue="$1"
100     local qdir="$2"
101     local to="${3}"
102
103     date -u -R >> REPORT
104     dak process-policy "${queue}" | tee -a REPORT | mail -a "X-Debian: DAK" -e -s "NEW changes in ${queue}" -a "From: Debian FTP Masters <ftpmaster@ftp-master.debian.org>" "${to}"
105     echo >> REPORT
106
107     dak generate-packages-sources2 -s "${queue}"
108
109     STAMP=${STAMP:-$(date "+%Y%m%d%H%M")}
110
111     local exportdir="${qdir}/tree/${STAMP}"
112     local targetdir="${qdir}/export"
113     mkdir -p -- ${exportdir}
114     dak export -q "${queue}" -d "${exportdir}" --all
115     ln -sfT ${exportdir} ${targetdir}
116     find "${qdir}/tree" -mindepth 1 -maxdepth 1 -not -name "${STAMP}" -type d -print0 | xargs --no-run-if-empty -0 rm -rf
117 }
118
119 # These versions used in dinstall
120 function punew() {
121     log "Doing automated p-u-new processing"
122     cd "${queuedir}/p-u-new"
123     punew_do "$1" "${queuedir}/p-u-new" "debian-release@lists.debian.org"
124 }
125
126 function opunew() {
127     log "Doing automated o-p-u-new processing"
128     cd "${queuedir}/o-p-u-new"
129     punew_do "$1" "${queuedir}/o-p-u-new" "debian-release@lists.debian.org"
130 }
131
132 function backports_policy() {
133     local queue="backports-policy"
134     local qdir="/srv/backports-master.debian.org/queue/policy"
135     local to="backports-team@debian.org"
136
137     log "Doing automated ${queue} processing"
138
139     cd "${qdir}"
140     punew_do "${queue}" "${qdir}" "${to}"
141 }
142
143 # Do the unchecked processing, in case we have files.
144 function do_unchecked () {
145     cd $unchecked
146
147     changes=$(find . -maxdepth 1 -mindepth 1 -type f -name \*.changes | sed -e "s,./,," | xargs)
148     report=$queuedir/REPORT
149     timestamp=$(date "+%Y-%m-%d %H:%M")
150     UNCHECKED_WITHOUT_LOCK=${UNCHECKED_WITHOUT_LOCK:-""}
151
152     echo "$timestamp": ${changes:-"Nothing to do"}  >> $report
153     dak process-upload -a ${UNCHECKED_WITHOUT_LOCK} -d "$unchecked" >> $report
154     dak process-commands -d "$unchecked" >> $report
155
156     if [ ! -z "$changes" ]; then
157         sync_debbugs
158         do_buildd
159     fi
160 }
161
162 # process NEW policy queue
163 function do_new () {
164     log "Doing NEW processing"
165     (dak process-policy new; dak process-policy byhand) | mail -a "X-Debian: DAK" -e -s "NEW and BYHAND processing" -a "From: Debian FTP Masters <ftpmaster@ftp-master.debian.org>" ftpmaster@ftp-master.debian.org
166
167     dak process-policy backports-new | mail -a "X-Debian: DAK" -e -s "NEW processing for backports-new" -a "From: Debian FTP Masters <ftpmaster@ftp-master.debian.org>" backports-team@debian.org
168
169     dak clean-suites -a new,backports-new
170 }
171
172 function sync_debbugs () {
173     # sync with debbugs
174     echo "--" >> $report
175     timestamp=$(date "+%Y-%m-%d-%H:%M")
176     mkdir -p $queuedir/bts_version_track_archive/${timestamp}
177     rsync -aq $queuedir/bts_version_track/ $queuedir/bts_version_track_archive/${timestamp}
178     rmdir --ignore-fail-on-non-empty $queuedir/bts_version_track_archive/${timestamp} # remove if empty.
179     rsync -aq -e "ssh -o Batchmode=yes -o ConnectTimeout=30 -o SetupTimeout=30" --remove-source-files  $queuedir/bts_version_track/ bugs-sync:/srv/bugs.debian.org/versions/queue/ftp-master/ 2>/dev/null && touch $lockdir/synced_bts_version || true
180     NOW=$(date +%s)
181     TSTAMP=$(stat -c %Y $lockdir/synced_bts_version)
182     DIFF=$(( NOW - TSTAMP ))
183     if [ $DIFF -ge 259200 ]; then
184         log "Kids, you tried your best and you failed miserably. The lesson is, never try. (Homer Simpson)"
185     fi
186 }
187
188 function clean_debbugs () {
189     # Delete files older than 60 days
190     find $queuedir/bts_version_track_archive/ -mtime +60 -type f -delete
191     # Delete empty directories
192     find $queuedir/bts_version_track_archive/ -empty -type d -delete
193 }
194
195 function reports() {
196     # Send a report on NEW/BYHAND packages
197     log "Nagging ftpteam about NEW/BYHAND packages"
198     dak queue-report | mail -a "X-Debian: DAK" -e -s "NEW and BYHAND on $(date +%D)" -a "From: Debian FTP Masters <ftpmaster@ftp-master.debian.org>" ftpmaster@ftp-master.debian.org
199     dak queue-report -d backports-new,backports-policy | mail -a "X-Debian: DAK" -e -s "NEW and POLICY on $(date +%D)" -a "From: Debian FTP Masters <ftpmaster@ftp-master.debian.org>" backports-team@debian.org
200     # and one on crufty packages
201     log "Sending information about crufty packages"
202     dak cruft-report -R > $webdir/cruft-report-daily.txt
203     dak cruft-report -R -s experimental >> $webdir/cruft-report-daily.txt
204     cat $webdir/cruft-report-daily.txt | mail -a "X-Debian: DAK" -e -s "Debian archive cruft report for $(date +%D)" -a "From: Debian FTP Masters <ftpmaster@ftp-master.debian.org>" ftpmaster@ftp-master.debian.org
205 }
206
207 function pg_timestamp() {
208     tsname=${1:-"unknown"}
209     log "Saving postgres transaction id for ${tsname}"
210     psql -tAc 'select txid_current();' > $base/backup/txid_${tsname}_$(date +%Y.%m.%d-%H:%M:%S)
211 }
212
213 function get_archiveroot() {
214     local archivename="$1"
215     local query="SELECT path FROM archive WHERE name='${archivename}'"
216     local archiveroot="$(psql -tAc "${query}")"
217     if [ -z "${archiveroot}" ]; then
218         echo "get_archiveroot: couldn't get archiveroot for '${archivename}'" >&2
219         return 1
220     fi
221     echo "${archiveroot}"
222 }
223
224 # Prepare the trees for buildds, then push wanna-build
225 function do_buildd() {
226     if lockfile -r3 ${LOCK_DAILY}; then
227         TMPFILES="${TMPFILES} ${LOCK_DAILY}"
228         make_buildd_dir
229         wbtrigger
230     fi
231 }
232
233 # Cleanup policy queues
234 function cleanpolicy() {
235     dak clean-suites -a backports-policy,policy
236 }
237
238 # Scan new packages for contents
239 function scancontents() {
240     dak contents -l 10000 scan-binary
241     dak contents -l 1000 scan-source
242 }
243
244 function ddaccess() {
245     # Tell our dd accessible mirror to sync itself up. Including ftp dir.
246     log "Trigger dd accessible parts sync including ftp dir"
247     ${scriptsdir}/sync-dd dd-sync dd-sync1 dd-sync2 sync
248 }
249
250
251
252 ########################################################################
253 ########################################################################
254 ########################################################################
255 ########################################################################
256
257 # Function to save which stage we are in, so we can restart an interrupted
258 # dinstall. Or even run actions in parallel, if we dare to, by simply
259 # backgrounding the call to this function. But that should only really be
260 # done for things we don't care much about.
261 #
262 # This should be called with the first argument being an array, with the
263 # members
264 #  - FUNC - the function name to call
265 #  - ARGS - Possible arguments to hand to the function. Can be the empty string
266 #  - TIME - The timestamp name. Can be the empty string
267 #  - ERR  - if this is the string false, then the call will be surrounded by
268 #           set +e ... set -e calls, so errors in the function do not exit
269 #           dinstall. Can be the empty string, meaning true.
270 #
271 # MAKE SURE TO KEEP THIS THE LAST FUNCTION, AFTER ALL THE VARIOUS ONES
272 # ADDED FOR DINSTALL FEATURES!
273 function stage() {
274     ARGS='GO[@]'
275     local "${!ARGS}"
276
277     local error=${ERR:-"true"}
278
279     ARGS=${ARGS:-""}
280
281     log "########## ${PROGRAM} BEGIN: ${FUNC} ${ARGS} ##########"
282     local STAGEFILE="${stagedir}/${FUNC}_${ARGS}"
283     STAGEFILE=${STAGEFILE// /_}
284     if [ -f "${STAGEFILE}" ]; then
285         local stamptime=$(/usr/bin/stat -c %Z "${STAGEFILE}")
286         local unixtime=$(date +%s)
287         local difference=$(( $unixtime - $stamptime ))
288         if [ ${difference} -ge 14400 ]; then
289             log_error "Did already run ${FUNC}, stagefile exists, but that was ${difference} seconds ago. Please check."
290         else
291             log "Did already run ${FUNC}, not calling again..."
292         fi
293         return
294     fi
295
296     debug "Now calling function ${FUNC}. Arguments: ${ARGS}. Timestamp: ${TIME}"
297
298     # Make sure we are always at the same place. If a function wants
299     # to be elsewhere, it has to cd first!
300     cd ${configdir}
301
302     # Now redirect the output into $STAGEFILE.log. In case it errors
303     # out somewhere our errorhandler trap can then mail the contents
304     # of $STAGEFILE.log only, instead of a whole ${PROGRAM} logfile.
305     # Short error mails ftw!
306     exec >> "${STAGEFILE}.log" 2>&1
307
308     if [ -f "${LOCK_STOP}" ]; then
309         log "${LOCK_STOP} exists, exiting immediately"
310         exit 42
311     fi
312
313     # Do we care about trouble in the function we call?
314     if [ "${error}" = "false" ]; then
315         set +e
316     fi
317     ${FUNC} ${ARGS}
318
319     # No matter what happened in the function, we make sure we have
320     # set -e default state back
321     set -e
322
323     # Make sure we are always at the same place.
324     cd ${configdir}
325
326     # We always use the same umask. If a function wants to do
327     # different, fine, but we reset.
328     umask 022
329
330     touch "${STAGEFILE}"
331
332     if [ -n "${TIME}" ]; then
333         ts "${TIME}"
334     fi
335
336     # And the output goes back to the normal logfile
337     exec >> "${LOGFILE}" 2>&1
338
339     # Now we should make sure that we have a usable ${PROGRAM}.log, so
340     # append the $STAGEFILE.log to it.
341     cat "${STAGEFILE}.log" >> "${LOGFILE}"
342     rm -f "${STAGEFILE}.log"
343
344     log "########## ${PROGRAM} END: ${FUNC} ##########"
345
346     if [ -f "${LOCK_STOP}" ]; then
347         log "${LOCK_STOP} exists, exiting immediately"
348         exit 42
349     fi
350 }